// BrowsDlg.cpp : implementation file
//
//
// SyncURLs Version 1.4
// Copyright  1998 Ziff-Davis Inc.
// First published in PC Magazine, US Edition
// January 6, 1998
// Written by Gregory A. Wolking
//

#include "stdafx.h"
#include "SyncURLs.h"
#include "StatDlg.h"
#include "SUDoc.h"
#include "BrowsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBrowsDlg dialog


CBrowsDlg::CBrowsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBrowsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBrowsDlg)
	m_bIgnoreNSC = FALSE;
	//}}AFX_DATA_INIT
	m_bUseAlternateNSPath = FALSE;
}


void CBrowsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBrowsDlg)
	DDX_Control(pDX, IDC_cmbSelectUser, m_cmbSelectUser);
	DDX_Check(pDX, IDC_chkIgnoreNSC, m_bIgnoreNSC);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBrowsDlg, CDialog)
	//{{AFX_MSG_MAP(CBrowsDlg)
	ON_BN_CLICKED(IDC_cmdHelp, OnHelp)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_HELP, OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBrowsDlg message handlers

void CBrowsDlg::OnOK() 
{
	int			nSel;
	CString		strUserName,
				strFileName;

	UpdateData(TRUE);
	if (m_bIgnoreNSC)
	{
		m_pMyDoc->m_strNSCUserName.Empty();
		m_pMyDoc->m_strNSCPath.Empty();
		m_pMyDoc->m_bNSCPresent = FALSE;
	}
	else
	{
		nSel = m_cmbSelectUser.GetCurSel();
		m_cmbSelectUser.GetLBText(nSel, strUserName);
		if (m_bUseAlternateNSPath)
			strFileName = m_strAlternateNSPath + strUserName;
		else
			Retrieve_Path(strUserName, strFileName);
		if (strFileName.Right(1) != '\\')
			strFileName += '\\';
		strFileName += "BOOKMARK.HTM";
		m_pMyDoc->m_strNSCUserName = strUserName;
		m_pMyDoc->m_strNSCPath = strFileName;
	}
	CDialog::OnOK();
}

BOOL CBrowsDlg::OnInitDialog() 
{
	int nCount;

	CDialog::OnInitDialog();
	Get_User_Names();
	nCount = m_cmbSelectUser.GetCount();
	switch (nCount)
	{
	case 0:
		AfxMessageBox("SyncURLs has located settings for one or more Netscape 4.x user profiles.\n"
			"However, either the files and folders specified in your Registry do not exist\n"
			"or you do not have permission to access them.", MB_ICONINFORMATION);
		m_pMyDoc->m_bNSCPresent = FALSE;
		EndDialog(IDOK);
		break;
	case 1:
		if (m_nUserCount == 1)
		{
			OnOK();
			break;
		}
		if (m_nUserCount > 1)
			AfxMessageBox("SyncURLs has located settings for multiple Netscape 4.x\n"
			"user profiles, but only one user profile can be accessed.", MB_ICONINFORMATION);
	}
	return TRUE;
}

// Populates the drop-list with Netsape user names.
void CBrowsDlg::Get_User_Names()
{
	char				szBuff[_MAX_PATH];
	HKEY				hKey;
	DWORD				len,
						key_index = 0;
	HANDLE				hFind;
	HRESULT				hResult;
	CString				strFileName,
						strSearchSpec;
	WIN32_FIND_DATA		fd;

	hResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE, sz_CommunicatorKey, 0, KEY_ENUMERATE_SUB_KEYS, &hKey);
	if (hResult != ERROR_SUCCESS)
		return;
	len = _MAX_PATH;
	m_nUserCount = 0;
	// Try to retrieve user profile info from the Registry.
	do
	{
		// Try to retrieve current key.
		hResult = RegEnumKeyEx(hKey, key_index, szBuff, &len, 0, NULL, NULL, NULL);
		if (hResult != ERROR_SUCCESS)
			break;
		if (Retrieve_Path(szBuff, strFileName))		// Retrieve path from the current key.
		{
			++m_nUserCount;							// Increment count.
			if (strFileName.Right(1) != '\\')		// Make sure path has trailing backslash.
				strFileName += '\\';
			strFileName += "BOOKMARK.HTM";			// Tack on "BOOKMARK.HTM".
			if (Check_Access(strFileName))			// Can we access the file?
				m_cmbSelectUser.AddString(szBuff);	// Yes ... add user name to the list box.
		}
		++key_index;								// Next key.
		len = sizeof(szBuff);
	} while (hResult != ERROR_NO_MORE_ITEMS);		// Loop until there are no more keys left.
	RegCloseKey(hKey);

	// If no user info was present in the registry,
	if (m_nUserCount == 0)
	{
		::GetWindowsDirectory(szBuff, _MAX_PATH);					// Get windows "home" directory.
		strcpy(&szBuff[3], "Program Files\\Netscape\\Users\\");		// Set search path using Windows "home" drive.
		strSearchSpec = szBuff;
		strSearchSpec += "*.*";
		hFind = FindFirstFile(strSearchSpec, &fd);					// See if there's anything there.
		if (hFind != INVALID_HANDLE_VALUE)							// If so, 
		{
			do 
			{
				// Is current directory item a folder?
				if ((fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == FILE_ATTRIBUTE_DIRECTORY)
				{
					if (strcmp(fd.cFileName, ".") == 0)			// Is it the "." folder?
						continue;								// Yes .. skip it.
					if (strcmp(fd.cFileName, "..") == 0)		// Is it the ".." folder?
						continue;								// Yes .. skip it.
					// Build filespec for BOOKMARK.HTM.
					strFileName.Format("%s%s\\BOOKMARK.HTM", szBuff, fd.cFileName);
					if (Check_Access(strFileName))					// Can we access the file?
					{
						m_cmbSelectUser.AddString(fd.cFileName);	// Yes .. add user to the list
						++m_nUserCount;								// and update the count.
					}
				}
				
			} while (FindNextFile(hFind, &fd));		// Continue with next directory entry.
		}
		if (m_nUserCount != 0)				// Found any users?
		{
			m_bUseAlternateNSPath = TRUE;	// Yes .. use alternate path.
			m_strAlternateNSPath = szBuff;	// Save alternate path.
		}
	}
	m_cmbSelectUser.SetCurSel(0);	// Make sure list box has first item selected.
}

// Retrieves the path for the specified Netscape Communicator user profile.
BOOL CBrowsDlg::Retrieve_Path(LPCTSTR szDataName, CString & strFileName)
{
	HKEY			hKey;
	HRESULT			hResult;
	unsigned char	szBuff1[_MAX_PATH];
	char			szBuff2[_MAX_PATH];
	DWORD			dwLen, dwType;
	CString			strKeyName;

	// Build key name for current user.
	strKeyName.Format("%s\\%s", sz_CommunicatorKey, szDataName);
	// Try to open the key.
	hResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE, strKeyName, 0, KEY_QUERY_VALUE, &hKey);
	if (hResult != ERROR_SUCCESS)
		return FALSE;
	dwLen = sizeof(szBuff1);
	dwType = 0;
	// Try to retrieve the "DirRoot" value.
	hResult = RegQueryValueEx(hKey, "DirRoot", 0, &dwType, szBuff1, &dwLen);
	RegCloseKey(hKey);
	if (hResult != ERROR_SUCCESS)
		return FALSE;
	switch(dwType)
	{
	case REG_SZ:						// If data is ASCIIZ,
		strFileName = szBuff1;			// Just copy the filename.
		return TRUE;
	case REG_EXPAND_SZ:					// If needed, expand environemnt strings.
		if (ExpandEnvironmentStrings((const char *)szBuff1, szBuff2, sizeof(szBuff2)) != 0)
		{
			strFileName = szBuff2;
			return TRUE;
		}
	default:
		return FALSE;
	}
}

// Ensures that the specified file exists and, if it does,
// that the user can both read from it and write to it.
BOOL CBrowsDlg::Check_Access(LPCTSTR szFileName)
{
	CFile file;

	if (file.Open(szFileName, CFile::modeRead, NULL))				// Does file even exist?
	{
		file.Close();												// Yes ... close it.
		if (file.Open(szFileName, CFile::modeReadWrite, NULL))		// Can we get read/write access?
		{
			file.Close();											// Yes .. close it,
			return TRUE;											// indicate success.
		}
	}
	return FALSE;
}

void CBrowsDlg::OnCancel()	// Make sure that {Esc} doesn't close the dialog.
{
}

void CBrowsDlg::OnHelp()
{
	CDialog::OnHelp();
}
