// FindDlg.cpp : implementation file
//
//
// SyncURLs Version 1.4
// Copyright  1998 Ziff-Davis Inc.
// First published in PC Magazine, US Edition
// January 6, 1998
// Written by Gregory A. Wolking
//

#include "stdafx.h"
#include "SyncURLs.h"
#include "FindDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFindDlg dialog


CFindDlg::CFindDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFindDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFindDlg)
	m_bIgnoreCase = FALSE;
	m_intLook = -1;
	m_strTarget = _T("");
	m_intSearchStart = -1;
	//}}AFX_DATA_INIT
}


void CFindDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFindDlg)
	DDX_Control(pDX, IDC_txtTarget, m_txtTarget);
	DDX_Check(pDX, IDC_chkIgnoreCase, m_bIgnoreCase);
	DDX_Radio(pDX, IDC_optLook1, m_intLook);
	DDX_Text(pDX, IDC_txtTarget, m_strTarget);
	DDV_MaxChars(pDX, m_strTarget, 64);
	DDX_Radio(pDX, IDC_optStart1, m_intSearchStart);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFindDlg, CDialog)
	//{{AFX_MSG_MAP(CFindDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFindDlg message handlers

void CFindDlg::OnOK() 
{
	UpdateData(TRUE);
	if (m_strTarget.IsEmpty())
	{
		AfxMessageBox("Search string must not be empty!", MB_ICONINFORMATION);
		m_txtTarget.SetFocus();
		return;
	}
	AfxGetApp()->WriteProfileInt("Settings", "IgnoreCase", m_bIgnoreCase);
	CDialog::OnOK();
}

BOOL CFindDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_bIgnoreCase = AfxGetApp()->GetProfileInt("Settings", "IgnoreCase", FALSE);
	return TRUE;
}
