// MainFrm.cpp : implementation of the CMainFrame class
//
//
// SyncURLs Version 1.4
// Copyright  1998 Ziff-Davis Inc.
// First published in PC Magazine, US Edition
// January 6, 1998
// Written by Gregory A. Wolking
//

#include "stdafx.h"
#include "SyncURLs.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSyncURLsApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_GETMINMAXINFO()
	ON_COMMAND(ID_HELP_INTRO, OnHelpIntro)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	CString		strParms;
	CRect		rectTarget, rectMin(0, 0, 300, 200);
	UINT		nShowState;

	// This section of code is pure AppWizard stuff.
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	// End of AppWizard-generated code.

	// Retrieve window position data.
	strParms = theApp.GetProfileString("Settings", "MainWindowPos", "*");
	if (strParms != "*")		// If data was there,
	{
		// Retrieve the numeric values.
		if (sscanf(strParms, "%u,%i,%i,%i,%i", &nShowState, &rectTarget.left, &rectTarget.top, &rectTarget.right, &rectTarget.bottom) == 5)
		{
			// Adjust window position if needed, and move it there.
			theApp.Adjust_Window_Pos(this, rectTarget, rectMin);
			// Note: We don't want to call ShowWindow() here because
			// CSyncURLsApp is going to call ShowWindow() automatically once
			// our creation process is complete, using the value stored in 
			// the m_nCmdShow member variable. If program was launched from
			// a shortcut with its "Run" field set to either "Minimized" or
			// "Maximized", then m_nCmdShow will be either SW_MINIMIZE or SW_MAXIMIZE
			// instead of SW_SHOWNORMAL. We want the shortcut setting to take precedence, therefore:
			if (theApp.m_nCmdShow == SW_SHOWNORMAL)		// If m_nCmdShow is SW_SHOWNORMAL,
				theApp.m_nCmdShow = nShowState;			// override with our saved state.
		}
	}
	return 0;	// Creation succeeds.
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	lpMMI->ptMinTrackSize.x = 300;		// Set minimum window size.
	lpMMI->ptMinTrackSize.y = 200;
	CFrameWnd::OnGetMinMaxInfo(lpMMI);
}

void CMainFrame::OnHelpIntro() 
{
	WinHelp(INTRO_TOPIC);	
}

void CMainFrame::OnClose() 
{
	CRect		rect;
	CString		strParms;
	UINT		nShowState = SW_SHOWNORMAL;		// Default state = normal.

	if (IsIconic())						// Are we minized?
		nShowState = SW_MINIMIZE;		// set state.
	else if (IsZoomed())				// Otherwise, are we maximized?
		nShowState = SW_MAXIMIZE;		// Set state.
	if (nShowState != SW_SHOWNORMAL)	// If minimized or maximized,
		ShowWindow(SW_RESTORE);		// restore to normal position first.
	GetWindowRect(&rect);			// Get window position.
	// Format string containing window state & position.
	strParms.Format("%u,%i,%i,%i,%i", nShowState, rect.left, rect.top, rect.right, rect.bottom);
	// Save it to the Registry.
	theApp.WriteProfileString("Settings", "MainWindowPos", strParms);
	CFrameWnd::OnClose();
}
