// MyTree.cpp : implementation file
//
//
// SyncURLs Version 1.4
// Copyright  1998 Ziff-Davis Inc.
// First published in PC Magazine, US Edition
// January 6, 1998
// Written by Gregory A. Wolking
//

#include "stdafx.h"
#include "SyncURLs.h"
#include "MyTree.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyTree

CMyTree::CMyTree()
{
}

CMyTree::~CMyTree()
{
}


BEGIN_MESSAGE_MAP(CMyTree, CTreeCtrl)
	//{{AFX_MSG_MAP(CMyTree)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyTree message handlers

// Override allows us to handle our own custom sort order
// so that items are inserted in alphabetical order, folders first.
HTREEITEM CMyTree::InsertItem(LPTV_INSERTSTRUCT lpInsertStruct)
{
	if (lpInsertStruct->hInsertAfter == TVI_SORT)		// Sort requested?
	{
		lpInsertStruct->hInsertAfter = TVI_FIRST;		// Yes. Default = top of tree.
		if (lpInsertStruct->hParent != TVI_ROOT)		// Parent not the root?
		{
			HTREEITEM	hItem;							// Yes .. create the variables we need.
			char		buff[MAX_PATH];
			TV_ITEM		info;
			info.mask = TVIF_TEXT | TVIF_IMAGE;				// Initialize TV_ITEM structure.
			info.pszText = buff;
			info.cchTextMax = sizeof(buff);
			hItem = GetChildItem(lpInsertStruct->hParent);	// Get our parent's first child.
			// Loop continues until we either find the existing item that would preceed
			// us in the sort order, or we run out of items so we go to the end of the list.
			while (hItem != NULL)
			{
				info.hItem = hItem;							// Retrieve current item's info.
				GetItem(&info);
				if (lpInsertStruct->item.iImage != 1)		// Is new item a folder?
				{
					if (info.iImage == 1)					// Is current item a bookmark?
						break;								// Yes .. let tree control insert it.
					if (stricmp(info.pszText, lpInsertStruct->item.pszText) > 0)	// Does new item follow the current item alphabetically?
						break;														// Yes .. let tree control insert it.
				}
				else										// Target item is a bookmark.
				{
					if (info.iImage == 1)					// If current item is a bookmark,
						if (stricmp(info.pszText, lpInsertStruct->item.pszText) > 0)	// and its text preceeds the new item alphabetically,
							break;							// Let the tree control insert it.
				}
				lpInsertStruct->hInsertAfter = hItem;		// Insert position = after the current item.
				hItem = GetNextSiblingItem(hItem);			// Get next sibling item and keep going.
			}
		}
	}
	return CTreeCtrl::InsertItem(lpInsertStruct);
}
