// SUView.h : interface of the CSUView class
//
//
// SyncURLs Version 1.4
// Copyright  1998 Ziff-Davis Inc.
// First published in PC Magazine, US Edition
// January 6, 1998
// Written by Gregory A. Wolking
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SUVIEW_H__A03AD40E_1CC5_11D1_84C6_444553540000__INCLUDED_)
#define AFX_SUVIEW_H__A03AD40E_1CC5_11D1_84C6_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

int __cdecl Compare_Dupe_URLs(const void* p1, const void* p2);

class CSUView : public CFormView
{
protected: // create from serialization only
	CSUView();
	DECLARE_DYNCREATE(CSUView)

public:
	//{{AFX_DATA(CSUView)
	enum { IDD = IDD_SYNCURLS_FORM };
	CMyTree	m_tvnFolders;
	//}}AFX_DATA

// Attributes
public:
	CSUDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSUView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnDraw(CDC* pDC);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	CImageList		m_imgTree;
	CImageList		m_imgState;
	BOOL m_bIsDragging;
	virtual ~CSUView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CSUView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnEditRename();
	afx_msg void OnUpdateEditRename(CCmdUI* pCmdUI);
	afx_msg void OnSelchangedtvnFolders(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnRclicktvnFolders(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBegindragtvnFolders(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnEditDel();
	afx_msg void OnUpdateEditDel(CCmdUI* pCmdUI);
	afx_msg void OnOptConfirmBookmark();
	afx_msg void OnUpdateOptConfirmBookmark(CCmdUI* pCmdUI);
	afx_msg void OnClicktvnFolders(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnOptConfirmFolder();
	afx_msg void OnUpdateOptConfirmFolder(CCmdUI* pCmdUI);
	afx_msg void OnEditNew();
	afx_msg void OnViewProperties();
	afx_msg void OnUpdateViewProperties(CCmdUI* pCmdUI);
	afx_msg void OnEditWeed();
	afx_msg void OnUpdateEditWeed(CCmdUI* pCmdUI);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnViewExpand();
	afx_msg void OnViewCollapse();
	afx_msg void OnOptAuto();
	afx_msg void OnEditFind();
	afx_msg void OnEditFindNext();
	afx_msg void OnUpdateEditFindNext(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditFind(CCmdUI* pCmdUI);
	afx_msg void OnExportManual();
	afx_msg void OnExportNs();
	afx_msg void OnExportMsie();
	afx_msg void OnExportBoth();
	afx_msg void OnExportNsc();
	afx_msg void OnOptFollow();
	afx_msg void OnUpdateOptFollow(CCmdUI* pCmdUI);
	afx_msg void OnKeydowntvnFolders(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclktvnFolders(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	BOOL Safe_Rename(LPCTSTR pszOldName, LPCTSTR pszNewName, UINT nMsg = 0);
	void Format_Date_Field(time_t nDate, CString& strDate);
	// Variables
	int				m_intScrollRate;
	int				m_intSearchIn;
	BOOL			m_bSearchStart;
	BOOL			m_bSearchCase;
	BOOL			m_bConfirmFolderDelete;
	BOOL			m_bConfirmBookmarkDelete;
	BOOL			m_bFollow;
	UINT			m_nDeletedItem;
	HTREEITEM		m_hDragDest;
	HTREEITEM		m_hDragSource;
	HTREEITEM		m_hCurItem;
	CString			m_strSearchText;
	CImageList *	m_pDragImage;
	CSUDoc *		m_pMyDoc;
	CStdioFile *	m_pFile;

	// Member functions
	BOOL Locate_Folder(HTREEITEM hParent, UINT nOffset);
	BOOL IsLocked(HTREEITEM item);
	BOOL IsBookmark(HTREEITEM hItem);
	BOOL IsFolder(HTREEITEM hItem);
	BOOL Process_Path(UINT nPathOffset, HTREEITEM hParentItem);
	BOOL Search_Tree(HTREEITEM hStart);
	BOOL Weed_Duplicates();
	void Expand_All(HTREEITEM hItem, BOOL bExpand);
	void Adjust_Folder_Offsets(HTREEITEM item, UINT offset);
	void Set_State_Up(HTREEITEM hItem);
	void Set_State_Down(HTREEITEM item, BOOL state);
	void Move_Folder(BOOL bRename = FALSE);
	void Adjust_Bookmarks(HTREEITEM parent);
	void Move_Bookmark(BOOL bRename = FALSE);
	void Write_NS_File(BOOL bBackup = TRUE);
	void Write_NS_Folder(HTREEITEM hThisFolder);
	HTREEITEM Next_Tree_Item(HTREEITEM hItem);
	HTREEITEM Move_Tree_Folder(HTREEITEM hSource, HTREEITEM hDest);
	friend class CWeedDlg;
};

#ifndef _DEBUG  // debug version in SUView.cpp
inline CSUDoc* CSUView::GetDocument()
   { return (CSUDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SUVIEW_H__A03AD40E_1CC5_11D1_84C6_444553540000__INCLUDED_)
