// SyncURLs.cpp : Defines the class behaviors for the application.
//
//
// SyncURLs Version 1.4
// Copyright  1998 Ziff-Davis Inc.
// First published in PC Magazine, US Edition
// January 6, 1998
// Written by Gregory A. Wolking
//

#include "stdafx.h"
#include "SyncURLs.h"

#include "MyTree.h"
#include "MainFrm.h"
#include "StatDlg.h"
#include "SUDoc.h"
#include "SUView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSyncURLsApp

BEGIN_MESSAGE_MAP(CSyncURLsApp, CWinApp)
	//{{AFX_MSG_MAP(CSyncURLsApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSyncURLsApp construction

CSyncURLsApp::CSyncURLsApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSyncURLsApp object

CSyncURLsApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CSyncURLsApp initialization

BOOL CSyncURLsApp::InitInstance()
{
	CString strCmdLine(m_lpCmdLine);

	strCmdLine.MakeLower();
	if (strCmdLine.Find("/uninstall") != -1)
	{
		if (::MessageBox(NULL, "Are you sure you want to uninstall SyncURLs?",
			"SyncURLs", MB_YESNO | MB_ICONQUESTION) == IDYES)
		{
			RegDeleteKey(HKEY_CURRENT_USER, "Software\\PC Magazine\\SyncURLs");
			RegDeleteKey(HKEY_CLASSES_ROOT, "SyncURLs.Document");
			RegDeleteKey(HKEY_CLASSES_ROOT, ".bml");
			::MessageBox(NULL, "SyncURLs data has been removed from the Registry\n\n"
				"You may now delete the program from disk.", "SyncURLs", MB_ICONINFORMATION);
			return FALSE;
		}
	}
	if (!SUCCEEDED(CoInitialize(NULL)))
	{
		::MessageBox(NULL, "Unable to initialize COM libraries", "SyncURLs", MB_OK | MB_ICONSTOP);
		return FALSE;
	}
	SetRegistryKey(_T("PC Magazine"));
	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CSUDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CSUView));
	AddDocTemplate(pDocTemplate);

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(FALSE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CSyncURLsApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


void CSyncURLsApp::OnFileOpen()
{
	CWinApp::OnFileOpen();
}

/////////////////////////////////////////////////////////////////////////////
// CSyncURLsApp commands

int CSyncURLsApp::ExitInstance() 
{
	CoUninitialize();	
	return CWinApp::ExitInstance();
}

// Used to adjust the restored position of a window, in case the
// screen resolution or desktop area changed so that the saved
// position has the window off the screen.
// Input:	pTarget = pointer to the CWnd that's calling us.
//			rectTarget = desired size and position in screen coordinates.
//			rectMinSize = minimum window size in pixels.
void CSyncURLsApp::Adjust_Window_Pos(CWnd *pTarget, CRect& rectTarget, CRect &rectMinSize)
{
	CRect rectDesktop;

	// Get the current desktop work area.
	SystemParametersInfo(SPI_GETWORKAREA, 0, &rectDesktop, 0);
	// Make sure the CRects are normalized so the remaining function calls don't fail.
	rectDesktop.NormalizeRect();
	rectTarget.NormalizeRect();
	// If our top-left corner is off the screen,
	if (!rectDesktop.PtInRect(rectTarget.TopLeft()))
	{
		// Make sure we fit entirely within the available desktop area.
		rectTarget.OffsetRect((rectDesktop.TopLeft() + CPoint(10, 10)) - rectTarget.TopLeft());
	}
	else
	{
		if (rectTarget.right > rectDesktop.right)						// Is right edge off the screen?
		{
			rectTarget.right = rectDesktop.right;						// Yes .. align with right edge.
			if (rectTarget.Width() < rectMinSize.right)					// Too narrow?
				rectTarget.left = rectTarget.right - rectMinSize.right;		// Yes .. make it wider.
		}
		if (rectTarget.bottom > rectDesktop.bottom)					// Is bottom edge off the screen?
		{
			rectTarget.bottom = rectDesktop.bottom;					// Yes .. align with bottom.
			if (rectTarget.Height() < rectMinSize.bottom)					// Too short?
				rectTarget.top = rectTarget.bottom - rectMinSize.bottom;	// Yes .. make it taller.
		}
	}
	pTarget->MoveWindow(&rectTarget, TRUE);				// Set window's "normal" position.
}
