// SyncURLs.h : main header file for the SYNCURLS application
//
//
// SyncURLs Version 1.4
// Copyright  1998 Ziff-Davis Inc.
// First published in PC Magazine, US Edition
// January 6, 1998
// Written by Gregory A. Wolking
//

#if !defined(AFX_SYNCURLS_H__A03AD406_1CC5_11D1_84C6_444553540000__INCLUDED_)
#define AFX_SYNCURLS_H__A03AD406_1CC5_11D1_84C6_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

// Note that all of the elements of these structures are 4 bytes in size,
// so packing them at 4-byte boundaries prevents wasting memory because
// of the compiler's default of 8-byte boundaries.
#pragma pack (4)
// Structure for bookmark array.
typedef struct
{
	UINT nPath;				// Offset into path array for parent folder.
	CString* pPage;			// Pointer to bookmark name.
	CString* pUrl;			// Pointer to URL string.
	CString* pComment;		// Pointer to comment string (NULL = no comment present)
	LONG nAdd;				// Date added (Netscape only)
	LONG nMod;				// Modified date (Netscape only)
	LONG nVisit;			// Last visit date (Netscape only)
} DOC_ELEMENT;

// Structure for path list array.
typedef struct 
{
	CString* pPath;		// Pointer to path name.
	BOOL bProcessed;	// Flag used by recursive routines.
	UINT nParent;		// Array offset to its parent directory.
	BOOL bLocked;		// Indicates folder exists on disk.
	UINT nSelected;		// Selection state for export:
						// 1 = not selected
						// 2 = fully selceted (i.e., all subfolders are selected)
						// 3 = partially selected (i.e., some subfolders are not selected)
} PATH_ELEMENT;

// Structure used when checking document for duplicate
// bookmark names.
typedef struct
{
	CString* pName;		// Bookmark name.
	UINT nOffset;		// Offset into the document array.
} DUP_ELEMENT;

// Structures used for weeding duplicate URLs
// Duplicate element
typedef struct 
{
	CString* pUrl;	// Pointer to URL string.
	UINT nOffset;	// Array offset.
	BOOL bRemove;	// Removal flag.
} DUP_URL_ELEMENT;

// Duplicate sets used by CWeedDlg.
typedef struct 
{
	UINT nStart;	// Starting index of this set.
	UINT nEnd;		// Ending index of this set.
} DUP_URL_SET;

#pragma pack()
/////////////////////////////////////////////////////////////////////////////
// CSyncURLsApp:
// See SyncURLs.cpp for the implementation of this class
//

class CSyncURLsApp : public CWinApp
{
public:
	void Adjust_Window_Pos(CWnd* pTarget, CRect& rectTarget, CRect& rectMinSize);
	CSyncURLsApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSyncURLsApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CSyncURLsApp)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	afx_msg void OnFileOpen();
	DECLARE_MESSAGE_MAP()
private:
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SYNCURLS_H__A03AD406_1CC5_11D1_84C6_444553540000__INCLUDED_)
